using System;
using System.IO;
using System.Text;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using sampleIME.control;
using sampleIME.util;

namespace sampleIME
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        // ͊m蕶
        string inputted;

        // ͒
        string inputting;

        // ϊ
        string[] candidate;

        // I
        int selection;

        FontDraw fontDraw;

        // t[v
        string fps = "FPS: calculating...";

        // t[v
        double ftime = 0;

        // t[JEg
        int frame = 0;

        // L[
        string pressKey = string.Empty;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            graphics.PreferredBackBufferWidth = 320;
            graphics.PreferredBackBufferHeight = 240;

            this.IsMouseVisible = true;
        }

        /// <summary>
        /// 
        /// </summary>
        protected override void Initialize()
        {
            TextInput.Initialize(Window);

            // Cxgo^
            TextInput.InputtedText += new InputEventHandler(inputtedText);
            TextInput.InputtingText += new InputEventHandler(inputtingText);
            TextInput.ChangeCandidate += new ConvertEventHandler(changeCandidate);
            TextInput.KeyDown += new KeyEventHandler(KeyDown);
            TextInput.KeyUp += new KeyEventHandler(KeyUp);

            base.Initialize();
        }

        /// <summary>
        /// Regǂݍ
        /// </summary>
        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // XvCgWFl[^
            fontDraw = new FontDraw(spriteBatch);

            SpriteGenerator.Initalize(graphics.GraphicsDevice, Window.Handle);
        }

        /// <summary>
        /// Regj
        /// </summary>
        protected override void UnloadContent()
        {
        }

        /// <summary>
        /// XV
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            ftime += gameTime.ElapsedGameTime.TotalSeconds;
            if (ftime > 1)
            {
                fps = String.Format("FPS: {0}", frame);
                ftime -= 1;
                frame = 0;
            }

            KeyboardState keyState = Keyboard.GetState();

            // F1 ŃtXN[
            if (!pushed && keyState.IsKeyDown(Keys.F1))
            {
                graphics.ToggleFullScreen();
            }
            // ԋL
            pushed = keyState.IsKeyDown(Keys.F1);

            // Escape ŏI
            if (keyState.IsKeyDown(Keys.Escape)) Exit();

            base.Update(gameTime);
        }

        bool pushed;

        /// <summary>
        /// `
        /// </summary>
        protected override void Draw(GameTime gameTime)
        {
            // frame add
            frame++;

            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();

            // g
            fontDraw.Draw("gFePL[˃tXN[@drbˏI", new Vector2(10, 10), Color.Yellow);

            // FPS            
            fontDraw.Draw(fps, new Vector2(10, 30), Color.White);

            // IME ON/OFF
            fontDraw.Draw(String.Format("IME: {0}", TextInput.Enabled), new Vector2(10, 50));

            // ͊m̕`
            Vector2 pos = new Vector2(10, 70);
            pos = fontDraw.Draw(inputted, pos);

            // ͒̕`
            fontDraw.Draw(inputting, pos, Color.Gold);

            // ϊ`
            if (candidate != null)
            {
                int start = (int)Math.Floor(selection / 10f) * 10;
                int count = Math.Min(start + 10, candidate.Length);
                for (int ii = start; ii < count; ii++)
                {
                    pos.Y += 15;
                    if (ii == selection)
                        fontDraw.Draw(candidate[ii], pos, Color.Red);
                    else
                        fontDraw.Draw(candidate[ii], pos, Color.Pink);
                }
            }

            spriteBatch.End();

            base.Draw(gameTime);
        }

        /// <summary>
        /// ͊m
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void inputtedText(object sender, StringEventArgs e)
        {
            inputting = string.Empty;
            candidate = null;

            if (e.Text.Equals("\r") || e.Text.Equals("\t"))
                return;

            if (e.Text.Equals("\b"))
            {
                if (inputted != null && inputted.Length > 0)
                    inputted = inputted.Remove(inputted.Length - 1);
            }
            else
            {
                inputted += e.Text;
            }
        }

        /// <summary>
        /// ͒
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void inputtingText(object sender, StringEventArgs e)
        {
            // ΏۊO
            if (e.Text.Equals("\r") || e.Text.Equals("\t")) return;

            inputting = e.Text;
        }

        /// <summary>
        /// ϊύX
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void changeCandidate(object sender, ConversionEventArgs e)
        {
            this.candidate = e.Candidate;
            this.selection = e.Selection;
        }

        /// <summary>
        /// L[_ECxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void KeyDown(object sender, KeyEventArgs e)
        {
        }

        /// <summary>
        /// L[AbvCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void KeyUp(object sender, KeyEventArgs e)
        {
        }
    }


    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        static void Main(string[] args)
        {
            using (Game1 game = new Game1())
            {
                game.Run();
            }
        }
    }
}

