using System;
using System.Drawing;
using System.IO;using System.Runtime.InteropServices;
using System.Text;

namespace sampleIME.control
{
    public class Ime
    {
        // ߕ
        static string[] clause;

        public static string[] ClauseString
        {
            get { return clause; }
        }

        // ߑ
        static int[] clauseAttribute;

        public static int[] ClauseAttribute
        {
            get { return clauseAttribute; }
        }

        // ϊ
        static string candiate;

        public static string CandiateString
        {
            get { return candiate; }
        }

        // ҏW
        static string edit;

        public static string EditingString
        {
            get { return edit; }
        }

        // Window bZ[W
        const int WM_NCDESTROY       = 0x0082;

        // ϊ
        const int GCS_COMPREADATTR   = 0x0002;
        const int GCS_COMPREADCLAUSE = 0x0004;
        const int GCS_COMPSTR        = 0x0008;
        const int GCS_COMPCLAUSE     = 0x0020;
        const int GCS_RESULTSTR      = 0x0800;

        // IMEXe[^X:̓[h
        const int IME_CMODE_ALPHANUMERIC    = 0x0000; // p̓[h
        const int IME_CMODE_NATIVE          = 0x0001; // NATIVEi{j̓[h
        const int IME_CMODE_JAPANESE        = 0x0001; //
        const int IME_CMODE_KATAKANA        = 0x0002; // J^Ji[hiOFF͂Ђ炪ȃ[hj
        const int IME_CMODE_LANGUAGE        = 0x0003; //
        const int IME_CMODE_FULLSHAPE       = 0x0008; // Sp[hiOFF͔p[hj
        const int IME_CMODE_ROMAN           = 0x0010; // [}
        const int IME_CMODE_CHARCODE        = 0x0020; // R[h
        const int IME_CMODE_HANJACONVERT    = 0x0040; //
        const int IME_CMODE_SOFTKBD         = 0x0080; //
        const int IME_CMODE_NOCONVERSION    = 0x0100; // ϊiOFF͕ϊj
        const int IME_CMODE_EUDC            = 0x0200; //
        const int IME_CMODE_SYMBOL          = 0x0400; //
        const int IME_CMODE_FIXED           = 0x0800; //

        [DllImport("Imm32.dll")]
        static extern IntPtr ImmGetContext(IntPtr hWnd);

        [DllImport("imm32.dll")]
        static extern int ImmReleaseContext(IntPtr hWnd, IntPtr hIMC);

        [DllImport("imm32.dll")]
        static extern IntPtr ImmGetDefaultIMEWnd(IntPtr hWnd);

        [DllImport("Imm32.dll")]
        static extern IntPtr ImmAssociateContext(IntPtr hWnd, IntPtr hIMC);

        [DllImport("imm32.dll")]
        static extern int ImmGetCompositionString(IntPtr hIMC, int dwIndex, byte[] lpBuf, int dwBufLen);

        [DllImport("imm32.dll")]
        private static extern int ImmGetCandidateList(IntPtr hIMC, int dwIndex, byte[] lpBuf, int dwBufLen);

        [DllImport("user32.dll")]
        static extern int SendMessage(IntPtr hWnd, int msg, int wParam, int lParam);

        IntPtr Handle;
        IntPtr hIMC;
        IntPtr hWnd;

        public Ime(IntPtr Handle)
        {
            this.Handle = Handle;
            this.hWnd = ImmGetDefaultIMEWnd(Handle);
            this.hIMC = ImmGetContext(Handle);
            ImmReleaseContext(Handle, hIMC);
        }

        /// <summary>
        /// ReLXgEBhEɊ֘AÂ
        /// </summary>
        public void AssociateContext()
        {
            // EChEɊ֘AÂ
            ImmAssociateContext(Handle, hIMC);

            // EChEj
            DestroyWindow();
        }

        /// <summary>
        /// 
        /// </summary>
        public void Initalize()
        {
            edit     = null;
            clause   = null;
            candiate = null;
            clauseAttribute = null;
        }

        /// <summary>
        /// ͒̕擾
        /// </summary>
        public string Inputting()
        {
            edit = GetCompositionString(GCS_COMPSTR);
            byte[] sBuf = Encoding.Default.GetBytes(edit);
            byte[] aBuf = GetCompositionByte(GCS_COMPREADATTR);
            int[] iBuf = GetCompositionInt32(GCS_COMPCLAUSE);
            int[] rBuf = GetCompositionInt32(GCS_COMPREADCLAUSE);
            if (iBuf.Length == 0) return edit;

            clause = new string[iBuf.Length - 1];
            clauseAttribute = new int[iBuf.Length - 1];
            for (int i = 0; i < iBuf.Length - 1; i++)
            {
                int iIdx = iBuf[i];
                int iLen = iBuf[i + 1] - iBuf[i];
                int rIdx = rBuf[i];
                int rLen = rBuf[i + 1] - rBuf[i];
                string text = Encoding.Default.GetString(sBuf, iIdx, iLen);
                byte[] attribute = new byte[rLen];
                Buffer.BlockCopy(aBuf, rIdx, attribute, 0, rLen);
                clause[i] = text;
                clauseAttribute[i] = attribute[0];
                if (attribute[0] == 1) candiate = text;
            }
            return edit;
        }

        /// <summary>
        /// ͊m̕擾
        /// </summary>
        public string Inputted()
        {
            return GetCompositionString(GCS_RESULTSTR);
        }

        /// <summary>
        /// ϊ擾
        /// </summary>
        public ConversionEventArgs ConversionCandidate()
        {
            int len = ImmGetCandidateList(hIMC, 0, null, 0);
            if (len == 0) return null;

            byte[] buf = new byte[len - 1];
            ImmGetCandidateList(hIMC, 0, buf, len);

            int size = BitConverter.ToInt32(buf, 0);
            //int style = BitConverter.ToInt32(buf, 4);
            int countAll = BitConverter.ToInt32(buf, 8);
            int selection = BitConverter.ToInt32(buf, 12);
            //int page = BitConverter.ToInt32(buf, 16);
            //int count = BitConverter.ToInt32(buf, 20);
            int offset = BitConverter.ToInt32(buf, 24);
            string text = Encoding.Default.GetString(
                            buf, offset - 1, size - offset);
            string[] candiate = text.Split(separator, 
                            StringSplitOptions.RemoveEmptyEntries);
            return new ConversionEventArgs(candiate, selection, countAll);
        }
        // Zp[^
        static readonly char[] separator = { '\0' };

        /// <summary>
        /// 擾
        /// </summary>
        string GetCompositionString(int param)
        {
            int len = ImmGetCompositionString(hIMC, param, new byte[0], 0);
            byte[] buf = new byte[len];
            ImmGetCompositionString(hIMC, param, buf, len);
            return Encoding.Default.GetString(buf);
        }

        /// <summary>
        /// ߏ擾
        /// </summary>
        int[] GetCompositionInt32(int param)
        {
            int len = ImmGetCompositionString(hIMC, param, new byte[0], 0);
            byte[] buf = new byte[len];
            ImmGetCompositionString(hIMC, param, buf, len);
            int count = (int)Math.Floor(buf.Length / 4f);
            int[] array = new int[count];
            for (int i = 0; i < count; i++)
                array[i] = BitConverter.ToInt32(buf, i * 4);
            return array;
        }

        /// <summary>
        /// oCgf[^擾
        /// </summary>
        byte[] GetCompositionByte(int param)
        {
            int len = ImmGetCompositionString(hIMC, param, new byte[0], 0);
            byte[] buf = new byte[len];
            ImmGetCompositionString(hIMC, param, buf, len);
            return buf;
        }

        /// <summary>
        /// EChEj
        /// </summary>
        void DestroyWindow()
        {
            SendMessage(hWnd, WM_NCDESTROY, 0, 0);
        }
    }
}
