using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace sampleIME.util
{
    public class FontDraw
    {
        SpriteBatch spriteBatch;

        // {̓tHgXvCggpׂłTv̂߁A
        // SpriteGenerator ŐQcXvCgtRNV
        // Ɋi[Ă܂BۂɎgpꍇ̓XvCgtH
        // ggp悤ɏĂB
        Dictionary<char, Texture2D> charmap;

        public SpriteGenerator spgen;

        public FontDraw(SpriteBatch spriteBatch)
        {
            this.spriteBatch = spriteBatch;
            charmap = new Dictionary<char, Texture2D>();
        }

        /// <summary>
        /// ftHgJ[ijŕ`
        /// </summary>
        public Vector2 Draw(string text, Vector2 position)
        {
            return Draw(text, position, Color.White);
        }

        /// <summary>
        /// J[w肵ĕ`
        /// </summary>
        public Vector2 Draw(string text, Vector2 position, Color color)
        {
            if (text == null) 
                return position;

            Vector2 offset = Vector2.Zero;
            foreach (char c in text.ToCharArray())
            {
                Texture2D texture;
                if (!charmap.ContainsKey(c))
                    charmap.Add(c, SpriteGenerator.CreateFontSprite(c, -1));

                texture = charmap[c];
                spriteBatch.Draw(texture, position + offset, color);
                offset.X += texture.Width;
            }
            return position + offset;
        }
    }
}
