using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using GraphicsDevice = Microsoft.Xna.Framework.Graphics.GraphicsDevice;
using Texture2D      = Microsoft.Xna.Framework.Graphics.Texture2D;
using TextureUsage   = Microsoft.Xna.Framework.Graphics.TextureUsage;
using SurfaceFormat  = Microsoft.Xna.Framework.Graphics.SurfaceFormat;

namespace sampleIME.util
{
    public class SpriteGenerator
    {
        // ftHgtHg
        public static readonly Font DEFAULT_FONT = new Font("MS UI Gothic", 9.5f);

        static private GraphicsDevice device;

        static private Graphics grahics;

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="device">Microsoft.Xna.Framework.Graphics.GraphicsDevice</param>
        /// <param name="hwnd">EChEʂnh</param>
        public static void Initalize(GraphicsDevice graphicsDevice, IntPtr hWnd)
        {
            if (device != null) 
                throw new InvalidOperationException("ɏς݂łB");

            grahics = Graphics.FromHwnd(hWnd);
            device = graphicsDevice;
        }

        /// <summary>
        /// ftHgtHgŕ񂩂XvCg𐶐܂B
        /// </summary>
        /// <param name="text">XvCg镶</param>
        /// <param name="argb">32 rbg ARGB lw肷lB</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateFontSprite(char text, int argb)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Color color = Color.FromArgb(argb);
            return CreateFontSprite(text.ToString(), DEFAULT_FONT, color);
        }

        /// <summary>
        /// ftHgtHgŕ񂩂XvCg𐶐܂B
        /// </summary>
        /// <param name="text">XvCg镶</param>
        /// <param name="argb">32 rbg ARGB lw肷lB</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateFontSprite(string text, int argb)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Color color = Color.FromArgb(argb);
            return CreateFontSprite(text, DEFAULT_FONT, color);
        }

        /// <summary>
        /// ftHgtHgŕ񂩂XvCg𐶐܂B
        /// </summary>
        /// <param name="text">XvCg镶</param>
        /// <param name="alpha">At@̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="red">Ԃ̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="green">΂̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="blue">̃R|[lgBLȒl 0  255 łB</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateFontSprite(string text, 
            int alpha, int red, int green, int blue)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Color color = Color.FromArgb(alpha, red, green, blue);
            return CreateFontSprite(text, DEFAULT_FONT, color);
        }

        /// <summary>
        /// tHgw肵ĕ񂩂XvCg𐶐܂B
        /// </summary>
        /// <param name="text">XvCg镶</param>
        /// <param name="familyName">System.Drawing.FontFamily ̕`B</param>
        /// <param name="emSize">tHg em TCYiPʂ̓|CgjB</param>
        /// <param name="argb">32 rbg ARGB lw肷lB</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateFontSprite(string text,
            string familyName, int emSize, int argb)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Color color = Color.FromArgb(argb);
            using (Font font = new Font(familyName, emSize)) {
                return CreateFontSprite(text, font, color);
            }
        }

        /// <summary>
        /// tHgw肵ĕ񂩂XvCg𐶐܂B
        /// </summary>
        /// <param name="text">XvCg镶</param>
        /// <param name="familyName">System.Drawing.FontFamily ̕`B</param>
        /// <param name="emSize">tHg em TCYiPʂ̓|CgjB</param>
        /// <param name="alpha">At@̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="red">Ԃ̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="green">΂̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="blue">̃R|[lgBLȒl 0  255 łB</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateFontSprite(string text, string familyName, 
            int emSize, int alpha, int red, int green, int blue)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Color color = Color.FromArgb(alpha, red, green, blue);
            using (Font font = new Font(familyName, emSize)) {
                return CreateFontSprite(text, font, color);
            }
        }

        /// <summary>
        /// w肵񂩂XvCg𐶐܂B
        /// </summary>
        /// <param name="text">XvCg镶</param>
        /// <param name="font">̃eLXg`` System.Drawing.Font</param>
        /// <param name="color"></param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateFontSprite(string text, Font font, Color color)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Size size = TextRenderer.MeasureText(grahics, text, font, new Size(0, 0), TextFormatFlags.NoPadding);
            Bitmap bmp = new Bitmap(size.Width, size.Height,
                                    PixelFormat.Format32bppArgb);
            using (Graphics g = Graphics.FromImage(bmp))
            {
                TextRenderer.DrawText(g, text, font, new Point(0, 0), color, TextFormatFlags.NoPadding);
                return BmpToTexture2D(bmp);
            }
        }

        /// <summary>
        /// AѕŎw肳ꂽOڂlp`ɂĒ`
        /// ȉ~̃XvCg𐶐܂B
        /// </summary>
        /// <param name="width">ȉ~`Oڂlp`̕B</param>
        /// <param name="height">ȉ~`Oڂlp`̍B</param>
        /// <param name="alpha">At@̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="red">Ԃ̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="green">΂̃R|[lgBLȒl 0  255 łB</param>
        /// <param name="blue">̃R|[lgBLȒl 0  255 łB</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateEllipseSprite(int width, int height,
            int alpha, int red, int green, int blue)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Color color = Color.FromArgb(alpha, red, green, blue);
            using (Pen pen = new Pen(color)) {
                return CreateEllipseSprite(width, height, color);
            }
        }

        /// <summary>
        /// AѕŎw肳ꂽOڂlp`ɂĒ`
        /// ȉ~̃XvCg𐶐܂B
        /// </summary>
        /// <param name="width">ȉ~`Oڂlp`̕B</param>
        /// <param name="height">ȉ~`Oڂlp`̍B</param>
        /// <param name="argb">32 rbg ARGB lw肷lB</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateEllipseSprite(int width, int height, int argb)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Color color = Color.FromArgb(argb);
            using (Pen pen = new Pen(color)) {
                return CreateEllipseSprite(width, height, color);
            }
        }

        /// <summary>
        /// AѕŎw肳ꂽOڂlp`ɂĒ`
        /// ȉ~̃XvCg𐶐܂B
        /// </summary>
        /// <param name="width">ȉ~`Oڂlp`̕B</param>
        /// <param name="height">ȉ~`Oڂlp`̍B</param>
        /// <param name="color">ȉ~̐F System.Drawing.Color \́B</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateEllipseSprite(int width, int height, Color color)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            using (Pen pen = new Pen(color))
            {
                return CreateEllipseSprite(pen, width, height);
            }
        }

        /// <summary>
        /// AѕŎw肳ꂽOڂlp`ɂĒ`
        /// ȉ~̃XvCg𐶐܂B
        /// </summary>
        /// <param name="pen">ȉ~̐FAAX^C肷 System.Drawing.PenB</param>
        /// <param name="width">ȉ~`Oڂlp`̕B</param>
        /// <param name="height">ȉ~`Oڂlp`̍B</param>
        /// <returns>Texture2D</returns>
        public static Texture2D CreateEllipseSprite(Pen pen, int width, int height)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            Bitmap bmp = new Bitmap(width + 1, height + 1, PixelFormat.Format32bppArgb);
            using (Graphics g = Graphics.FromImage(bmp))
            {
                g.DrawEllipse(pen, 0, 0, width, height);
                return BmpToTexture2D(bmp);
            }
        }

        /// <summary>
        /// rbg}bvXvCgɕϊ܂
        /// </summary>
        /// <param name="bmp">Bitmap</param>
        /// <returns>Texture2D</returns>
        static Texture2D BmpToTexture2D(Bitmap bmp)
        {
            if (device == null)
                throw new InvalidOperationException("Ă܂B");

            int w = bmp.Width, h = bmp.Height;
            Rectangle bmpRc = new Rectangle(0, 0, w, h);
            Texture2D tex2D = new Texture2D(device, w, h, 1,
                TextureUsage.None, SurfaceFormat.Color);
            BitmapData bmpData = bmp.LockBits(bmpRc, 
                ImageLockMode.ReadOnly, bmp.PixelFormat);

            IntPtr ptr = bmpData.Scan0;
            int stride = bmpData.Stride;
            int bytes = stride * h;
            byte[] b = new byte[bytes];
            Marshal.Copy(ptr, b, 0, bytes);
            bmp.UnlockBits(bmpData);
            tex2D.SetData<byte>(b);
            return tex2D;
        }
    }
}
